package service

import (
	"errors"

    "github.com/go-admin-team/go-admin-core/sdk/service"
	"gorm.io/gorm"

	"go-admin/app/admin/models"
	"go-admin/app/admin/service/dto"
	"go-admin/common/actions"
	cDto "go-admin/common/dto"
)

type LineUserFundingTrend struct {
	service.Service
}

// GetPage 获取LineUserFundingTrend列表
func (e *LineUserFundingTrend) GetPage(c *dto.LineUserFundingTrendGetPageReq, p *actions.DataPermission, list *[]models.LineUserFundingTrend, count *int64) error {
	var err error
	var data models.LineUserFundingTrend

	err = e.Orm.Model(&data).
		Scopes(
			cDto.MakeCondition(c.GetNeedSearch()),
			cDto.Paginate(c.GetPageSize(), c.GetPageIndex()),
			actions.Permission(data.TableName(), p),
		).
		Find(list).Limit(-1).Offset(-1).
		Count(count).Error
	if err != nil {
		e.Log.Errorf("LineUserFundingTrendService GetPage error:%s \r\n", err)
		return err
	}
	return nil
}

// Get 获取LineUserFundingTrend对象
func (e *LineUserFundingTrend) Get(d *dto.LineUserFundingTrendGetReq, p *actions.DataPermission, model *models.LineUserFundingTrend) error {
	var data models.LineUserFundingTrend

	err := e.Orm.Model(&data).
		Scopes(
			actions.Permission(data.TableName(), p),
		).
		First(model, d.GetId()).Error
	if err != nil && errors.Is(err, gorm.ErrRecordNotFound) {
		err = errors.New("查看对象不存在或无权查看")
		e.Log.Errorf("Service GetLineUserFundingTrend error:%s \r\n", err)
		return err
	}
	if err != nil {
		e.Log.Errorf("db error:%s", err)
		return err
	}
	return nil
}

// Insert 创建LineUserFundingTrend对象
func (e *LineUserFundingTrend) Insert(c *dto.LineUserFundingTrendInsertReq) error {
    var err error
    var data models.LineUserFundingTrend
    c.Generate(&data)
	err = e.Orm.Create(&data).Error
	if err != nil {
		e.Log.Errorf("LineUserFundingTrendService Insert error:%s \r\n", err)
		return err
	}
	return nil
}

// Update 修改LineUserFundingTrend对象
func (e *LineUserFundingTrend) Update(c *dto.LineUserFundingTrendUpdateReq, p *actions.DataPermission) error {
    var err error
    var data = models.LineUserFundingTrend{}
    e.Orm.Scopes(
            actions.Permission(data.TableName(), p),
        ).First(&data, c.GetId())
    c.Generate(&data)

    db := e.Orm.Save(&data)
    if err = db.Error; err != nil {
        e.Log.Errorf("LineUserFundingTrendService Save error:%s \r\n", err)
        return err
    }
    if db.RowsAffected == 0 {
        return errors.New("无权更新该数据")
    }
    return nil
}

// Remove 删除LineUserFundingTrend
func (e *LineUserFundingTrend) Remove(d *dto.LineUserFundingTrendDeleteReq, p *actions.DataPermission) error {
	var data models.LineUserFundingTrend

	db := e.Orm.Model(&data).
		Scopes(
			actions.Permission(data.TableName(), p),
		).Delete(&data, d.GetId())
	if err := db.Error; err != nil {
        e.Log.Errorf("Service RemoveLineUserFundingTrend error:%s \r\n", err)
        return err
    }
    if db.RowsAffected == 0 {
        return errors.New("无权删除该数据")
    }
	return nil
}
